// Generated by CoffeeScript 1.10.0
(function() {
  module.exports = function(pattern, pitch, span, height, pinCount) {
    var Cl, Cs, Cw, F, Gmin, Jh, Js, Jt, Lmax, Lmin, Ltol, P, Smax, SmaxRms, Smin, Stol, StolRms, Tmax, Tmin, Ttol, Wmax, Wmin, Wtol, Xmax, Zmax, bodyHeight, bodyWidth, courtyard, defaultShape, heel, housing, i, j, k, l, leadLength, lineWidth, num, pad, padDistance, padHeight, padSpace, padWidth, placeRoundoff, r, rectWidth, ref, ref1, ref2, ref3, results, settings, side, sizeRoundoff, toe, x, y;
    pitch /= 100.0;
    span /= 100.0;
    height /= 100.0;
    pinCount *= 1;
    housing = pattern.housing;
    settings = pattern.settings;
    toe = {
      L: 0.15,
      N: 0.35,
      M: 0.55
    };
    heel = {
      L: 0.25,
      N: 0.35,
      M: 0.45
    };
    side = pitch > 0.625 ? {
      L: 0.01,
      N: 0.03,
      M: 0.05
    } : {
      L: -0.04,
      N: -0.02,
      M: 0.01
    };
    courtyard = {
      L: 0.1,
      N: 0.25,
      M: 0.5
    };
    Lmin = housing.leadSpan.min;
    Lmax = housing.leadSpan.max;
    Ltol = housing.leadSpan.tol;
    Tmin = housing.leadLength.min;
    Tmax = housing.leadLength.max;
    Ttol = housing.leadLength.tol;
    Wmin = housing.leadWidth.min;
    Wmax = housing.leadWidth.max;
    Wtol = housing.leadWidth.tol;
    F = settings.tolerance.fabrication;
    P = 2 * settings.tolerance.placement;
    Jt = toe[settings.densityLevel];
    Jh = heel[settings.densityLevel];
    Js = side[settings.densityLevel];
    Smin = Lmin - 2 * Tmax;
    Smax = Lmax - 2 * Tmin;
    Stol = Ltol + 2 * Ttol;
    StolRms = Math.sqrt(Ltol * Ltol + 2 * Ttol * Ttol);
    SmaxRms = Smax - (Stol - StolRms) / 2;
    Cl = Ltol;
    Cs = StolRms;
    Cw = Wtol;
    Zmax = Lmin + 2 * Jt + Math.sqrt(Cl * Cl + F * F + P * P);
    Gmin = SmaxRms - 2 * Jh - Math.sqrt(Cs * Cs + F * F + P * P);
    Xmax = Wmin + 2 * Js + Math.sqrt(Cw * Cw + F * F + P * P);
    defaultShape = 'oval';
    if (Gmin < housing.bodyWidth.nom) {
      Gmin = housing.bodyWidth.nom;
      defaultShape = 'rectangle';
    }
    sizeRoundoff = settings.roundoff.size;
    placeRoundoff = settings.roundoff.place;
    padWidth = (Zmax - Gmin) / 2;
    padHeight = Xmax;
    padDistance = (Zmax + Gmin) / 2;
    padWidth = Math.ceil(padWidth / sizeRoundoff) * sizeRoundoff;
    padHeight = Math.ceil(padHeight / sizeRoundoff) * sizeRoundoff;
    padDistance = Math.round(padDistance / placeRoundoff) * placeRoundoff;
    pad = {
      type: 'smd',
      width: padWidth,
      height: padHeight
    };
    pattern.setLayer('top');
    y = -pitch * (pinCount / 4 - 0.5);
    num = 1;
    for (i = j = 1, ref = pinCount / 2; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      pad.name = num++;
      pad.x = -padDistance / 2;
      pad.y = y;
      pad.shape = i === 1 ? 'rectangle' : defaultShape;
      pattern.addPad(pad);
      y += pitch;
    }
    y -= pitch;
    for (i = k = ref1 = pinCount / 2 + 1, ref2 = pinCount; ref1 <= ref2 ? k <= ref2 : k >= ref2; i = ref1 <= ref2 ? ++k : --k) {
      pad.name = num++;
      pad.x = padDistance / 2;
      pad.y = y;
      pattern.addPad(pad);
      y -= pitch;
    }
    pattern.setLayer('topSilkscreen');
    lineWidth = settings.lineWidth.silkscreen;
    pattern.setLineWidth(lineWidth);
    rectWidth = housing.bodyWidth.nom;
    padSpace = padDistance - padWidth - 2 * settings.clearance.padToSilk - lineWidth;
    if (rectWidth >= padSpace) {
      rectWidth = padSpace;
    }
    bodyHeight = housing.bodyLength.nom;
    pattern.addRectangle({
      x: -rectWidth / 2,
      y: -bodyHeight / 2,
      width: rectWidth,
      height: bodyHeight
    });
    x = -rectWidth / 4;
    y = -bodyHeight / 2 + rectWidth / 4;
    r = rectWidth / 4 - 2 * lineWidth;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r
    });
    r = lineWidth;
    x = -padDistance / 2;
    y = -pitch * (pinCount / 4 - 0.5) - padHeight / 2 - r - settings.clearance.padToSilk;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    pattern.setLayer('topAssembly');
    pattern.setLineWidth(settings.lineWidth.assembly);
    bodyWidth = housing.bodyWidth.nom;
    leadLength = housing.leadLength.nom;
    pattern.addRectangle({
      x: -bodyWidth / 2,
      y: -bodyHeight / 2,
      width: bodyWidth,
      height: bodyHeight
    });
    y = -pitch * (pinCount / 4 - 0.5);
    num = 1;
    results = [];
    for (i = l = 1, ref3 = pinCount / 2; 1 <= ref3 ? l <= ref3 : l >= ref3; i = 1 <= ref3 ? ++l : --l) {
      pattern.addLine({
        x1: -bodyWidth / 2,
        y1: y,
        x2: -bodyWidth / 2 - leadLength,
        y2: y
      });
      pattern.addLine({
        x1: bodyWidth / 2,
        y1: y,
        x2: bodyWidth / 2 + leadLength,
        y2: y
      });
      results.push(y += pitch);
    }
    return results;
  };

}).call(this);
