// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol,
    slice = [].slice;

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(library, definition) {
      var h, i, j, len, len1, pinName, pinNumber, pinNumbers, ref;
      this.library = library;
      this.mergeObjects(this, definition);
      this.refDes = 'REF';
      this.symbol = new QedaSymbol(this);
      this.symbol.settings = this.library.symbol;
      this.patterns = [];
      this.pins = [];
      for (pinName in this.pinout) {
        pinNumbers = Array.isArray(this.pinout[pinName]) ? this.pinout[pinName] : [this.pinout[pinName]];
        for (i = 0, len = pinNumbers.length; i < len; i++) {
          pinNumber = pinNumbers[i];
          this.pins[pinNumber] = this._pinObj(pinNumber, pinName);
        }
      }
      if (!Array.isArray(this.housing)) {
        this.housing = [this.housing];
      }
      ref = this.housing;
      for (j = 0, len1 = ref.length; j < len1; j++) {
        h = ref[j];
        if (typeof h === 'object') {
          this.addPattern(h);
        } else if (typeof h === 'string') {
          if (this[h] != null) {
            this.addPattern(this[h]);
          }
        }
      }
    }

    QedaElement.prototype.addPattern = function(housing) {
      var pattern;
      if (housing.pattern == null) {
        return;
      }
      pattern = new QedaPattern(this, housing);
      pattern.settings = this.library.pattern;
      return this.patterns.push(pattern);
    };

    QedaElement.prototype.calculate = function(gridSize) {
      var cap, def, handler, i, j, l, len, len1, len2, len3, m, outline, pattern, ref, ref1, ref2, ref3, ref4, ref5;
      if (this._calculated == null) {
        this._calculated = false;
      }
      if (this._calculated) {
        return;
      }
      handler = require("./element/" + this.library.elementStyle);
      handler(this);
      if (((ref = this.schematics) != null ? ref.symbol : void 0) != null) {
        ref1 = this.library.symbolDefs;
        for (i = 0, len = ref1.length; i < len; i++) {
          def = ref1[i];
          cap = def.regexp.exec(this.schematics.symbol);
          if (cap) {
            handler = require("./symbol/" + this.library.symbolStyle + "/" + def.handler);
            handler.apply(null, [this.symbol].concat(slice.call(cap.slice(1))));
          }
        }
      }
      this.symbol.calculate(gridSize);
      ref2 = this.patterns;
      for (j = 0, len1 = ref2.length; j < len1; j++) {
        pattern = ref2[j];
        if (((ref3 = pattern.housing) != null ? ref3.outline : void 0) != null) {
          outline = pattern.housing.outline;
          ref4 = this.library.outlineDefs;
          for (l = 0, len2 = ref4.length; l < len2; l++) {
            def = ref4[l];
            cap = def.regexp.exec(outline);
            if (cap) {
              handler = require("./outline/" + def.handler);
              handler.apply(null, [pattern.housing].concat(slice.call(cap.slice(1))));
            }
          }
        }
        this._convertDimensions(pattern.housing);
        ref5 = this.library.patternDefs;
        for (m = 0, len3 = ref5.length; m < len3; m++) {
          def = ref5[m];
          cap = def.regexp.exec(pattern.name);
          if (cap) {
            handler = require("./pattern/" + this.library.patternStyle + "/" + def.handler);
            handler.apply(null, [pattern].concat(slice.call(cap.slice(1))));
          }
        }
      }
      return this._calculated = true;
    };

    QedaElement.prototype.isFloat = function(n) {
      return Number(n) && (n % 1 !== 0);
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype._convertDimensions = function(housing) {
      var key, max, min, nom, results, tol, value;
      results = [];
      for (key in housing) {
        value = housing[key];
        if (Array.isArray(value) && value.length > 0) {
          min = value[0];
          max = value.length > 1 ? value[1] : min;
          nom = (max + min) / 2;
          tol = max - min;
          results.push(housing[key] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          });
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var i, len, obj, pins, prop, props;
      obj = {
        name: name,
        number: number
      };
      if (this.properties != null) {
        props = ['ground', 'in', 'inverted', 'out', 'power'];
        for (i = 0, len = props.length; i < len; i++) {
          prop = props[i];
          if (this.properties[prop] != null) {
            pins = Array.isArray(this.properties[prop]) ? this.properties[prop] : [this.properties[prop]];
            obj[prop] = pins.indexOf(name) !== -1;
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
